<?php
class ControllerExtensionShippingFreePro extends Controller {
	private $error = array(); 
	private $release_version = '1.3.1';
	
	public function index() {   
		$path = 'shipping/free_pro';
		
		if (version_compare(VERSION, '2.3.0.0', '>=')) {
			$path = 'extension/' . $path;
		}
		
		$data['path'] = $path;
		
		$this->load->language($path);

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
		$this->load->model('localisation/country');
		$this->load->model('tool/image');
		
		$this->document->addScript("https://gitcdn.github.io/bootstrap-toggle/2.2.2/js/bootstrap-toggle.min.js");
		$this->document->addStyle("https://gitcdn.github.io/bootstrap-toggle/2.2.2/css/bootstrap-toggle.min.css");
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('shipping_free_pro', $this->request->post);		
					
			$this->session->data['success'] = $this->language->get('text_success');
			
			if (version_compare(VERSION, '2.3.0.0', '>=')) {			
				$this->response->redirect($this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true));
			} else {
				$this->response->redirect($this->url->link('extension/shipping', 'user_token=' . $this->session->data['user_token'], 'SSL'));
			}
		}
				
		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_select'] = $this->language->get('text_select');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_select_all'] = $this->language->get('text_select_all');
		$data['text_unselect_all'] = $this->language->get('text_unselect_all');
		$data['text_none'] = $this->language->get('text_none');
		$data['text_translate'] = $this->language->get('text_translate');
		$data['text_subtotal'] = $this->language->get('text_subtotal');
		$data['text_total'] = $this->language->get('text_total');
		
		$i = 0;
		$teaser_locations = array();
		
		while ($i < 5) {
			$i++;
			$key = 'text_teaser_' . $i;
			
			if (is_file('../image/catalog/fsp-example/teaser_example_'. $i . '.png')) {
				$image = $this->model_tool_image->resize('catalog/fsp-example/teaser_example_'. $i . '.png', (825*0.7), (398*0.7));
			}
			
			$setting_key = 'shipping_free_pro_teaser_' . $i;
			
			if (isset($this->request->post[$setting_key])) {
				$status = $this->request->post[$setting_key];
			} else {
				$status = $this->config->get($setting_key);
			}
			
			$teaser_locations[] = array(
				'key'		=> $setting_key,
				'text' 		=> $this->language->get($key),
				'image' 	=> (!empty($image) ? $image : '' ),
				'status' 	=> $status 
			);
		}
		
		$data['teaser_locations'] = $teaser_locations;
		
		$data['year'] = date('Y');
		$data['version'] = $this->release_version;
		
		$data['tab_rules'] = $this->language->get('tab_rules');
		$data['tab_languages'] = $this->language->get('tab_languages');
		
		$data['entry_debug'] = $this->language->get('entry_debug');
		$data['entry_exclusive_status'] = $this->language->get('entry_exclusive_status');
		$data['entry_total'] = $this->language->get('entry_total');
		$data['entry_weight'] = $this->language->get('entry_weight');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_geolocation_status'] = $this->language->get('entry_geolocation_status');
		$data['entry_geolocation_service'] = $this->language->get('entry_geolocation_service');
		$data['entry_teaser_status'] = $this->language->get('entry_teaser_status');
		$data['entry_autofill_status'] = $this->language->get('entry_autofill_status');
		$data['entry_store'] = $this->language->get('entry_store');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_country'] = $this->language->get('entry_country');
		$data['entry_zone'] = $this->language->get('entry_zone');
		$data['entry_customer_group'] = $this->language->get('entry_customer_group');
		$data['entry_teaser_status'] = $this->language->get('entry_teaser_status');
		$data['entry_freeshippingno'] = $this->language->get('entry_freeshippingno');
		$data['entry_freeshippingyes'] = $this->language->get('entry_freeshippingyes');
		$data['entry_freeshippingto'] = $this->language->get('entry_freeshippingto');
		$data['entry_freeshippingweight'] = $this->language->get('entry_freeshippingweight');
		
		$data['help_total'] = $this->language->get('help_total');
		$data['help_weight'] = $this->language->get('help_weight');
		$data['help_debug'] = $this->language->get('help_debug');
		$data['help_geolocation'] = $this->language->get('help_geolocation');
		$data['help_geolocation_service'] = $this->language->get('help_geolocation_service');
		$data['help_teaser'] = $this->language->get('help_teaser');
		$data['help_autofill'] = $this->language->get('help_autofill');
		$data['help_teaser_no'] = $this->language->get('help_teaser_no');
		
		$data['button_add'] = $this->language->get('button_add');
		$data['button_remove'] = $this->language->get('button_remove');
		$data['button_fallback'] = $this->language->get('button_fallback');
		$data['button_weight_limit'] = $this->language->get('button_weight_limit');
		$data['button_save'] = $this->language->get('button_save');
		$data['button_save_stay'] = $this->language->get('button_save_stay');
		$data['button_cancel'] = $this->language->get('button_cancel');
		
		$data['error_permission'] = $this->language->get('error_permission');
		
		$this->load->model('localisation/language');
		$data['languages'] = $this->model_localisation_language->getLanguages();	
 		
 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		
		foreach (array('no', 'yes', 'to', 'weight') as $key) {
			$var = 'error_teaser_' . $key;
			if (isset($this->error[$key])) {
				$data[$var] = $this->error[$key];
				$data['error_warning'] = $this->error['required'];
			} else {
				$data[$var] = array();
			}
		}
		
		$this->load->model('setting/store');
		$stores = $this->model_setting_store->getStores();
		
		if(empty($stores)) {
			$s[] = array(
				'store_id'	=> 0,
				'name'		=> $this->db->escape($this->config->get('config_name') . ' ' . $this->language->get('text_default'))
			);
		} else {
			foreach ($stores as $store) {
				$s[] = array(
					'store_id'	=> $store['store_id'],
					'name' 		=> $this->db->escape($store['name'])
				);
			}

			array_unshift($s, array(
				'store_id'	=> 0,
				'name'		=> $this->db->escape($this->config->get('config_name') . ' ' . $this->language->get('text_default')) 
			));
		}
		
		$data['stores'] = $s;
		
		$this->load->model('customer/customer_group');
		$customer_groups = $this->model_customer_customer_group->getCustomerGroups();
		
		foreach ($customer_groups as $customer_group) {
			$t[] = array(
				'customer_group_id' => $customer_group['customer_group_id'],
				'name' 				=> $customer_group['name']
			);
		}
		
		array_unshift($t, array(
            'customer_group_id' => 0,
            'name' 				=> $this->language->get('text_anonymous')
        ));
        
        $data['customer_groups'] = $t;
		
		$data['countries'] = $this->model_localisation_country->getCountries();
		
		$data['config_weight'] = $this->weight->getUnit($this->config->get('config_weight_class_id'));
		$data['config_currency_left'] = $this->currency->getSymbolLeft($this->config->get('config_currency'));
		$data['config_currency_right'] = $this->currency->getSymbolRight($this->config->get('config_currency'));
		
  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'user_token=' . $this->session->data['user_token'], 'SSL'),
   		);
		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_shipping'),
			'href'      => $this->url->link('extension/shipping', 'user_token=' . $this->session->data['user_token'], 'SSL'),
		);
		
		if (version_compare(VERSION, '2.3.0.0', '>=')) {
			$data['breadcrumbs'][] = array(
				'text'      => $this->language->get('heading_title'),
				'href'      => $this->url->link('extension/shipping/free_pro', 'user_token=' . $this->session->data['user_token'], 'SSL'),
			);
			$data['action'] = $this->url->link('extension/shipping/free_pro', 'user_token=' . $this->session->data['user_token'], 'SSL');
			$data['cancel'] = $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true);
   		} else {
			$data['breadcrumbs'][] = array(
				'text'      => $this->language->get('heading_title'),
				'href'      => $this->url->link('shipping/free_pro', 'user_token=' . $this->session->data['user_token'], 'SSL'),
			);
			$data['action'] = $this->url->link('shipping/free_pro', 'user_token=' . $this->session->data['user_token'], 'SSL');
			$data['cancel'] = $this->url->link('extension/shipping', 'user_token=' . $this->session->data['user_token'], 'SSL');
		}
		
		$data['permission'] = $this->user->hasPermission('modify', $path);
		$data['user_token'] = $this->session->data['user_token'];
		
		if (isset($this->request->post['shipping_free_pro_data'])) {
			$data['free_pro_shipping'] = $this->request->post['shipping_free_pro_data'];
		} elseif ($this->config->get('shipping_free_pro_data')) {
			$data['free_pro_shipping'] = $this->config->get('shipping_free_pro_data');
		} else {
			$data['free_pro_shipping'] = array();
		}
		
		$data['highest'] = count($data['free_pro_shipping']);
		
		$setting_keys = array(
			'status', 
			'sort_order', 
			'debug_status', 
			'geolocation_status',  
			'geolocation_service', 
			'service_fallback', 
			'autofill_status', 
			'teaser',
			'exclusive_status'
		);
		
		foreach ($setting_keys as $key) {
			$setting = 'shipping_free_pro_' . $key;
			if (isset($this->request->post[$setting])) {
				$data[$setting] = $this->request->post[$setting];
			} else {
				$data[$setting] = $this->config->get($setting);
			}
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');
				
		$this->response->setOutput($this->load->view( $path , $data));
	}
	
	public function saveSettings() {
		
		$json = array();
		
		$path = 'shipping/free_pro';
		
		if (version_compare(VERSION, '2.3.0.0', '>=')) {
			$path = 'extension/' . $path;
		}
		
		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			
			$this->load->language($path);
			
			parse_str(htmlspecialchars_decode($this->request->post['settings']), $settings);
			
			/* Validate input is not empty */
			foreach (array('no', 'yes', 'to', 'weight') as $key) {
				foreach ($settings['shipping_free_pro_teaser'] as $language_id => $value) {
					if ((utf8_strlen($value[$key]) < 1) || (utf8_strlen($value[$key]) > 255)) {
						$json['warning'][$key][$language_id] = $this->language->get('error_msg');
						$json['warning']['required'] = $this->language->get('error_required');
					}
				}
			}
			
			if (empty($json['warning'])) {
				$this->load->model('setting/setting');
				$this->model_setting_setting->editSetting('shipping_free_pro', $settings);
				$json['success'] = $this->language->get('text_success');
			}

		} else {
			$json['error'] = $this->language->get('error_warning');
		}
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
		
	}
	
	private function validate() {
		
		$path = 'shipping/free_pro';
		
		if (version_compare(VERSION, '2.3.0.0', '>=')) {
			$path = 'extension/' . $path ;
		}
		
		$this->load->language($path);
		
		if (!$this->user->hasPermission('modify', $path)) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		foreach (array('no', 'yes', 'to', 'weight') as $key) {
			foreach ($this->request->post['shipping_free_pro_teaser'] as $language_id => $value) {
				if ((utf8_strlen($value[$key]) < 1) || (utf8_strlen($value[$key]) > 255)) {
					$this->error[$key][$language_id] = $this->language->get('error_msg');
					$this->error['required'] = $this->language->get('error_required');
				}
			}
		}
		
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
	
	public function install() {
	
		$initial_settings = array(
			'shipping_free_pro_status' 				=> '1' ,
			'shipping_free_pro_status' 				=> $this->release_version ,
			'shipping_free_pro_sort_order' 			=> '1' ,
			'shipping_free_pro_debug_status'		=> '0' ,
			'shipping_free_pro_geolocation_status' 	=> '1' ,
			'shipping_free_pro_geolocation_service' => 'freegeoip',
			'shipping_free_pro_teaser_1' 			=> 'on' ,
			'shipping_free_pro_teaser_2' 			=> 'on' ,
			'shipping_free_pro_teaser_3' 			=> 'on' ,
			'shipping_free_pro_teaser_4' 			=> 'on' ,
			'shipping_free_pro_teaser_5' 			=> 'on' ,
			'shipping_free_pro_autofill_status' 	=> '1' ,
			'shipping_free_pro_exclusive_status' 	=> '1' 
		);
		
		$this->load->model('setting/setting');
		$this->model_setting_setting->editSetting('shipping_free_pro', $initial_settings);	
	
		return true;
	}
	
	public function uninstall() {
		$this->db->query("DELETE FROM `" . DB_PREFIX. "setting` WHERE `code` = 'shipping_free_pro';");
		return true;
	}
}
?>