<?php
class ModelExtensionShippingFreePro extends Model {
	function getQuote($address) {
		
		if (version_compare(VERSION, '2.3.0.0', '>=')) {
			$this->load->language('extension/shipping/free_pro');
		} else {
			$this->load->language('shipping/free_pro');
		}
				
		if ($this->customer->isLogged() == false) {
			$customer_group_id = 0;			
		} else {
			$customer_group_id = $this->customer->getGroupId();
		}
		
		/* caching */
		if (!empty($this->session->data['fsp'])) {
			$fsp = $this->session->data['fsp'];
		} else {
			$fsp = $this->getFSP($address, $customer_group_id);
		}
		
		if ($fsp['country_id'] != (int)$address['country_id']) {
			$fsp = $this->getFSP($address, $customer_group_id);
		}
		
		/* $fsp = $this->getFSP($address, $customer_group_id); */
		
		if ($fsp['country_id'] == (int)$address['country_id'] && ($fsp['zone_id'] == 0 ? true : $fsp['zone_id'] == (int)$address['zone_id']) && in_array($customer_group_id, $fsp['customer_group_id']) && in_array($this->config->get('config_store_id'), $fsp['store_id'])) {
			$status = true;
		} else {
			$status = false;
		}

		if ($fsp['type'] == 'subtotal' && $this->cart->getSubTotal() < $fsp['total']) {
			$status = false;
		} elseif ($fsp['type'] == 'total' && $this->getCartTotal() < $fsp['total']) {
			$status = false;
		}
		
		if (!empty($fsp['weight-limit'])) {
			if ($this->cart->getWeight() > $fsp['max-weight']) {
				$status = false;
			}
		}
		
		$method_data = array();
	
		if ($status) {
			$quote_data = array();
			
			$title = sprintf($this->language->get('text_description'), $address['country']);
      		$quote_data['free_pro'] = array(
        		'code'         => 'free_pro.free_pro',
        		'title'        => $title,
        		'cost'         => 0.00,
        		'tax_class_id' => 0,
				'text'         => $this->currency->format(0.00, $this->session->data['currency'])
      		);

      		$method_data = array(
        		'code'       => 'free_pro',
        		'title'      => $this->language->get('text_title'),
        		'quote'      => $quote_data,
				'sort_order' => $this->config->get('shipping_free_pro_sort_order'),
        		'error'      => false
      		);
		}
	
		return $method_data;
	}
	
	protected function getFSP($address, $customer_group_id) {
	
		$f = $this->config->get('shipping_free_pro_data');
		foreach ($f as $g) {
			if ($g['country_id'] == (int)$address['country_id'] && ($g['zone_id'] == 0 ? true : $g['zone_id'] == (int)$address['zone_id']) && in_array($customer_group_id, $g['customer_group_id'])) {
				$fsp = $g;
			}
		}
		return (empty($fsp) ? false : $fsp);
	}
	
	public function getTeaser() {
		
		$return = array();;
		$teaser_msg = $this->config->get('shipping_free_pro_teaser');
		$this->load->model('localisation/language');
		
		$msg_add = $teaser_msg[$this->model_localisation_language->getLanguageByCode($this->session->data['language'])]['no'] . ' ' . $teaser_msg[$this->model_localisation_language->getLanguageByCode($this->session->data['language'])]['to'];
		$msg_yes = $teaser_msg[$this->model_localisation_language->getLanguageByCode($this->session->data['language'])]['yes'] . ' ' . $teaser_msg[$this->model_localisation_language->getLanguageByCode($this->session->data['language'])]['to'];
		if (empty($this->session->data['fsp']['weight-limit']) ? 1 : $this->cart->getWeight() <= $this->session->data['fsp']['max-weight']) {
			
			if (($this->session->data['fsp']['type'] == 'subtotal' ? $this->cart->getSubTotal() : $this->getCartTotal()) < $this->session->data['fsp']['total'] ) {
				$return['class'] = 'alert alert-info information';
				$add = $this->session->data['fsp']['total'] - ($this->session->data['fsp']['type'] == 'subtotal' ? $this->cart->getSubTotal() : $this->getCartTotal());
				$return['message'] = sprintf($msg_add, $this->currency->format($add, $this->session->data['currency']), $this->session->data['country_data']['name']);
			} else  {	
				$return['class'] = 'alert alert-success success';	
				$return['message'] = sprintf($msg_yes, $this->session->data['country_data']['name']);
			}
		} else {
			$return['class'] = 'alert alert-danger attention';
			$return['message'] = $teaser_msg[$this->model_localisation_language->getLanguageByCode($this->session->data['language'])]['weight'];
		}
	
		return $return;
	}
		
	public function getCartTotal() {
		// Totals
		if (version_compare(VERSION, '3.0.0.0', '>=')) {
			$this->load->model('setting/extension');
		} else {
			$this->load->model('extension/extension');
		}

		$totals = array();
		$taxes = $this->cart->getTaxes();
		$total = 0;
		
		if (version_compare(VERSION, '2.2.0.0', '>=')) {
			$order_data = array();
			$totals = array();
			$total_data = array(
				'totals' => &$totals,
				'taxes'  => &$taxes,
				'total'  => &$total
			);
		} else {
			$total_data = array();
		}
		
		if (version_compare(VERSION, '2.3.0.0', '>=')) {
			$path = 'extension/';
			$load = 'extension_';
		} else {
			$path = '';
			$load = '';
		}
		
		$sort_order = array();
	
		if (version_compare(VERSION, '3.0.0.0', '>=')) {
			$results = $this->model_setting_extension->getExtensions('total');
			$prefix = 'total_';
		} else {
			$results = $this->model_extension_extension->getExtensions('total');
			$prefix = '';
		}

		foreach ($results as $key => $value) {
			$sort_order[$key] = $this->config->get($prefix . $value['code'] . '_sort_order');
		}

		array_multisort($sort_order, SORT_ASC, $results);

		foreach ($results as $result) {
			if ($this->config->get($prefix . $result['code'] . '_status')) {
				$this->load->model( $path . 'total/' . $result['code']);
				
				if (version_compare(VERSION, '2.2.0.0', '>=')) {
					$this->{'model_' . $load . 'total_' . $result['code']}->getTotal($total_data);
				} else {
					$this->{'model_total_' . $result['code']}->getTotal($total_data, $total, $taxes);
				}
			}
		}
		
		$sort_order = array();
		
		if (version_compare(VERSION, '2.2.0.0', '<')) {
			$totals = $total_data;
		}
		
		foreach ($totals as $key => $value) {
			$sort_order[$key] = $value['sort_order'];
		}

		array_multisort($sort_order, SORT_ASC, $totals);

		//$order_data['totals'] = $totals;

		$cart_total = end($totals);
		
		/*
		var_dump($totals);
		var_dump($cart_total);
		*/
		
		return $cart_total['value'];
	
	}
}